﻿using Microsoft.VisualBasic.CompilerServices;
using System;

namespace _02_Uebg_KlasseTimeOpOverloading
{
    class Time
    {
        int time;
        public Time(int std, int min) { time = 60 * std + min; }
        public Time(int fromMins) { time = fromMins; }
        public Time(string s)
        {
            string[] d = s.Split(':');
            time = Convert.ToInt32(d[0]) * 60 + Convert.ToInt32(d[1]);
        }

        public static Time operator +(Time t1, TimeSpan ts)
            => new Time(t1.time + ts.TotalMins);
        public static TimeSpan operator -(Time t1, Time t2) => new TimeSpan(t1.time - t2.time);
        //public static Time operator +(Time t1, int x)
        //    => new Time(t1.time + x);
        public static implicit operator Time(string s) => new Time(s);
        public override string ToString() => $"{time / 60}:{time % 60}";

        public static bool operator ==(Time t1, Time t2) => t1.time == t2.time;
        public static bool operator !=(Time t1, Time t2) => !(t1 == t2);
        public static bool operator true(Time t1) => t1.time < 12 * 60;
        public static bool operator false(Time t1) => t1.time >= 12 * 60;
    }
    class TimeSpan
    {
        int timeSpan;
        public TimeSpan(string s)
        {
            string[] d = s.Split(':');
            timeSpan = Convert.ToInt32(d[0]) * 60 + Convert.ToInt32(d[1]);
        }
        public TimeSpan(int fromMins) { timeSpan = fromMins; }
        public int TotalMins { get => timeSpan; }
        public static implicit operator TimeSpan(string s) => new TimeSpan(s);
        public static implicit operator TimeSpan(int fromMins) => new TimeSpan(fromMins);
        public override string ToString() => $"{timeSpan / 60}:{timeSpan % 60}";

    }
    class Program
    {
        // ToDo: Schreiben Sie die zwei Klassen Time und TimeSpan, sodass nachfolgendes Programm ausführbar ist
        // Sie können die Uhrzeit und die Zeitspanne intern gerne durch einen int realisieren und
        // nur für die Ausgaben in tatsächliche Std:Min-Ausgaben umwandeln.
        static void Main(string[] args)
        {
            Time t1 = new Time(9, 45);
            // Klasse Time, Konstruktor(int,int)
            Time t2 = (t1 + "1:30") + 15; 
            // Time.op+(Time,TimeSpan), TimeSpan:string->TimeSpan (impl), TimeSpan:int->TimeSpan (impl.)
            Time t3 = "11:30";
            // Time:string->Time, evtl. Time.Time(string)
            TimeSpan ts1 = t2 - t1;
            // TimeSpan.op-(Time, Time) ->TimeSpan
            Console.WriteLine(t2);
            // override Time.ToString()
            Console.WriteLine(ts1.TotalMins);
            // TimeSpan.TotalMins-get-Property
            Console.WriteLine(ts1);
            // override TimeSpan.ToString()
            if (t2)     // Time.op true&false
                Console.WriteLine("Guten Morgen");
            else
                Console.WriteLine("Guten Tag");
            if (t2 == t3)  // Time.op== & Time.op!= 
                Console.WriteLine("Die Uhrzeiten sind gleich!");
            else
                Console.WriteLine("Die Uhrzeiten stimmen nicht überein");
            // 11:30
            // 105
            // 1:45
            // Guten Morgen
            // Die Uhrzeiten sind gleich!
        }
    }
}
