﻿using System;

namespace _02_UebgSa_FiFoListe
{
    class FiFoListe
    {
        class Element
        {
            public string name;
            public Element next;
            public Element(string name) { this.name = name; }
            public override string ToString() => name;
        }
        Element anf, ende;
        int anz;
        public FiFoListe()
        {
            anf = ende = null;
            anz = 0;
        }
        /// <summary>
        /// Fügt der Warteschlange ein neues Element hinzu
        /// </summary>
        /// <param name="text"></param>
        public void Push(string text)
        {
            Element neuesElement = new Element(text);
            anz++;
            if (anf == null)  // Noch leere Liste?
                anf = ende = neuesElement;
            else
                ende = ende.next = neuesElement;
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="textFeld"></param>
        public void Push(params string[] textFeld)
        {
            foreach (string text in textFeld)
                Push(text);
        }
        /// <summary>
        /// Liefert das erste Element zurück. Es bleibt aber in der Warteschlange
        /// </summary>
        /// <returns></returns>
        public string First()   
        {
            return (anf == null) ? null : anf.name;
        }
        /// <summary>
        /// Liefert Wert des ersten Ausgabeelements zurück UND entfernt dieses aus der Warteschlange
        /// </summary>
        /// <returns></returns>
        public string Pop() // 
        {
            // 1.Fall: Liste ist leer
            // 2.Fall: Liste besteht nur aus *einem* Element
            // 3.Fall: Liste hat mehr als ein Element
            if (anf == null)  // 1. Fall
                return null;
            string erg = anf.name;   // Ein return anf.name würde die Methode zu früh beenden!!!
            anz--;
            anf = anf.next;   // 3. Fall
            if (anf == null)  // 2. Fall
                ende = null;
            return erg;
        }
        /// <summary>
        /// Gibt alle Elemente der Warteschlange auf dem Bildschirm aus
        /// </summary>
        public void WriteAll()  
        {
            for (Element tmp = anf; tmp != null; tmp = tmp.next)
                Console.WriteLine(tmp);
        }
        /// <summary>
        /// liefert ein string-Feld mit allen gespeicherten Elementen zurück; 
        /// Elemente verbleiben in der Liste
        /// </summary>
        /// <returns></returns>
        public string[] GetAll()
        {
            string[] textFeld = new string[anz];
            int i = 0;
            for (Element tmp = anf; tmp != null; tmp = tmp.next,i++)
                textFeld[i] = tmp.name;
            return textFeld;
        }
        /// <summary>
        /// Anzahl der Elemente in der Warteschlange zurückgeben
        /// </summary>
        public int ItemCount { get => anz; }
    }
    
    class Program
    {
        static void Main(string[] args)
        {
            FiFoListe f = new FiFoListe();
            f.Push("Anton");
            f.Push("Berta", "Claudia", "Dieter", "Emil", "Gustav");
            Console.WriteLine($"Anzahl der Elemente in der Liste: {f.ItemCount}");
            f.WriteAll();
            Console.WriteLine("--------------");
            Console.WriteLine($"Erstes Element: {f.First()}");
            Console.WriteLine($"Pop: {f.Pop()}");
            Console.WriteLine($"Pop: {f.Pop()}");
            Console.WriteLine($"Anzahl der Elemente in der Liste: {f.ItemCount}");
            Console.WriteLine("--------------");
            string[] namen = f.GetAll();
            foreach (string item in namen)
            {
                Console.WriteLine($"foreach: {item}");
            }
        }
    }
}
