﻿using System;

namespace _03_UebgDi_ZyklischeListe
{
    class CycleList
    {
        class Element
        {
            public string name;
            public Element next = null;
            public Element(string name) { this.name = name; }
            public override string ToString() => name;
        }
        Element anf = null, ende = null;
        Element iterator = null;
        public void AddEnd(string name)
        {
            Element neuesElement = new Element(name);   // 1. Neues Element anlegen
            if (anf == null)                            // 2. Leere Liste?
                anf = ende = neuesElement;
            else
                ende = ende.next = neuesElement;        // 3. Neues Element am Ende anfügen
            ende.next = anf;                            // Zyklus schließen: Ende auf Anf verweisen lassen
        }
        public void CloseCycle()
        {
            ende.next = anf;                            // Zyklus schließen: Ende auf Anf verweisen lassen
        }
        public void Print()
        {
            //for (Element item = anf; item != null; item = item.next)
            //    Console.WriteLine(item);
            if (anf == null)
                return;
            // Wir wissen: Es existiert mindestens EIN Element
            Element tmp = anf;
            do
            {
                Console.WriteLine(tmp);
                tmp = tmp.next;
            } while (tmp!=null && tmp != anf);
        }
        public void SetIterator(int offset = 0)
        {
            iterator = anf;
            for (int i = 0; i < offset; i++)
            {
                iterator = iterator.next;
            }
        }
        public string GetName() => iterator.name;
        public void MoveNext() { iterator = iterator.next; }
    }

    // ===========================================================
    class Program
    {
        static void Main(string[] args)
        {
            CycleList cl = new CycleList();
            cl.AddEnd("Anton");
            cl.AddEnd("Berta");
            cl.CloseCycle();
            cl.Print();
            Console.WriteLine("-------------");
            cl.AddEnd("Claudia");
            cl.AddEnd("Dieter");
            cl.CloseCycle();
            cl.Print();
            Console.WriteLine("-------------");
            cl.SetIterator(2);
            for (int i = 0; i < 10; i++)
            {
                Console.WriteLine(cl.GetName());
                cl.MoveNext();
            }
        }
    }
}
