﻿using System;
using System.Collections;

namespace _03_UebgMo_FiFoListe
{
    class FiFoListe
    {
        class Element
        {
            public string name;
            public Element next;

            public Element(string name) { this.name = name; }
            public override string ToString() => name;
        }
        Element anf, ende;
        int anz;
        public FiFoListe()
        {
            anf = ende = null;
            anz = 0;
        }
        /// <summary>
        /// Fügt der Warteschlange ein neues Element hinzu
        /// </summary>
        /// <param name="text"></param>
        public void Push(string text)
        {
            Element neu = new Element(text);
            anz++;
            if (anf == null)
                anf = ende = neu;
            else
            {
                ende.next = neu;
                ende = neu;
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="textFeld"></param>
        public void Push(params string[] textFeld)
        {
            foreach (string item in textFeld)
                Push(item);
        }
        /// <summary>
        /// Liefert das erste Element zurück. Es bleibt aber in der Warteschlange
        /// </summary>
        /// <returns></returns>
        public string First()
        {
            if(anf== null)
                throw new ArgumentNullException("Leere Warteschlange");
            else
                return anf.name;
        }
        /// <summary>
        /// Liefert Wert des ersten Ausgabeelements zurück UND entfernt dieses aus der Warteschlange
        /// </summary>
        /// <returns></returns>
        public string Pop() // 
        {
            // 1.Fall: Liste ist leer
            // 2.Fall: Liste besteht nur aus *einem* Element
            // 3.Fall: Liste hat mehr als ein Element
            if (anf == null)
                throw new ArgumentNullException("Liste ist leer");
            string erg = anf.name;
            if (anf == ende)
                anf = ende = null;
            else
                anf = anf.next;
            anz--;
            return erg;            
        }
        /// <summary>
        /// Gibt alle Elemente der Warteschlange auf dem Bildschirm aus
        /// </summary>
        public void WriteAll()
        {
            for (Element item = anf; item != null; item = item.next)
            {
                Console.WriteLine(item);
            }
        }
        /// <summary>
        /// liefert ein string-Feld mit allen gespeicherten Elementen zurück; 
        /// Elemente verbleiben in der Liste
        /// </summary>
        /// <returns></returns>
        public string[] GetAll()
        {
            if (anz == 0)
                return null;
            string[] erg = new string[anz];
            int i = 0;
            for (Element tmp = anf; tmp != null; tmp = tmp.next)
            {
                erg[i] = tmp.name;
                i++;
            }
            return erg;
        }
        public IEnumerator GetEnumerator()
        {
            for (Element tmp = anf; tmp != null; tmp = tmp.next)
            {
                yield return tmp.name;
            }
        }
        /// <summary>
        /// Anzahl der Elemente in der Warteschlange zurückgeben
        /// </summary>
        public int ItemCount { get => anz; }
    }

    class Program
    {
        static void Main(string[] args)
        {
            FiFoListe f = new FiFoListe();
            f.Push("Anton");
            f.Push("Berta", "Claudia", "Dieter", "Emil", "Gustav");
            Console.WriteLine($"Anzahl der Elemente in der Liste: {f.ItemCount}");
            f.WriteAll();
            Console.WriteLine("--------------");
            Console.WriteLine($"Erstes Element: {f.First()}");
            Console.WriteLine($"Pop: {f.Pop()}");
            Console.WriteLine($"Pop: {f.Pop()}");
            Console.WriteLine($"Anzahl der Elemente in der Liste: {f.ItemCount}");
            Console.WriteLine("--------------");
            string[] namen = f.GetAll();
            foreach (string item in namen)
            {
                Console.WriteLine($"foreach: {item}");
            }
            foreach (string item in f)
            {
                Console.WriteLine($"GetEnumerator: {item}");
            }
        }
    }
}
