﻿using System;

namespace _03DoppeltverketteteListe
{
    class Personenliste
    {
        class Element
        {
            public string name;
            public Element next=null, prev=null;
            public Element(string name) { this.name = name; }
            public override string ToString() => $"Name: {name},  prev: {(prev == null ? "null" : prev.name)}, next: {(next == null ? "null" : next.name)}";
        }
        Element anf, ende;
        public void AddEnd(string name)
        {
            Element neu = new Element(name);
            if (anf == null)
                anf = ende = neu;
            else
            {
                ende.next = neu;
                neu.prev = ende;
                ende = neu;
            }
        }
        public void AddFront(string name)
        {
            // 1. Leere Liste
            // 2. Es existiert mind. ein Element
            Element neuesElement = new Element(name);   // Neues Element anlegen

            if (anf == null)                            // 1.Fall: Leere Liste?
                anf = ende = neuesElement;
            else
            {
                neuesElement.next = anf;                // 2. Fall
                anf = anf.prev = neuesElement;
            }
        }

        public void AddSorted(string name)
        {
            // 1. Fall: Leere Liste oder Anfügen am Listenende
            if (anf == null || ende.name.CompareTo(name) <= 0)
                AddEnd(name);
            else
            {
                if (name.CompareTo(anf.name) <= 0)
                    AddFront(name);
                else
                {
                    // Wir wissen: Das neue Element ist nicht das erste und nicht das letzte Element
                    Element neu = new Element(name);

                    Element item = anf;
                    while (item.next.name.CompareTo(name) < 0)
                        item = item.next;
                    // bis hierher identisch zur einfach-verketteten Liste
                    item.next.prev = neu; // Rückwärtsverkettung vom nachfolgenden Listenelement
                    neu.next = item.next; // Vorwärtsverkettung vom neuen Element zur Restliste
                    neu.prev = item;      // Rückwärtsverkettung vom neuen Elenent zum Listenanfangsstück
                    item.next = neu;      // Vorwärtsverkettung zum neuen Element
                }
            }
        }
        public void DeleteFirst()
        {
            // 1.Fall: Liste ist leer
            // 2.Fall: Liste besteht nur aus einem Element
            // 3.Fall: Liste hat mehr als ein Element
            if (anf == null)  // 1. Fall
                return;
            if (anf == ende)  // 2. Fall
                anf = ende = null;
            else
            {
                anf = anf.next;   // 3. Fall
                anf.prev = null;
            }
        }
        public void DeleteByName(string name)
        {
            // leere Liste ohne Elemente
            if (anf == null)
                return;
            // erstes Element = gesuchtes Element
            if (anf.name.CompareTo(name) == 0)
                DeleteFirst();
            // Wir wissen jetzt:
            // Liste hat mind. ein Element UND das erste Element ist nicht das gesuchte Element
            else
            {
                Element item = anf;
                // Durchlaufen der Liste
                // solange Elemente in Liste vorhanden und gesuchtes Element noch nicht gefunden
                while (item.next != null && item.next.name.CompareTo(name) != 0)
                    item = item.next;
                // Wenn gesuchtes Element in Liste vorhanden
                if (item.next != null)
                {
                    if (item.next.next != null)
                    {
                        // Nächstes Element überspringen = löschen
                        item.next.next.prev = item;
                        item.next = item.next.next;
                    }
                    else
                    {
                        // Wenn gesuchtes Element == letztes Element:
                        item.next = null;
                        ende = item;
                    }
                }
            }
        }
        public void Print()
        {
            for (Element item = anf; item != null; item = item.next)
                Console.WriteLine(item);
        }
        public void PrintReverse()
        {
            for (Element item = ende; item != null; item = item.prev)
                Console.WriteLine(item);
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            Personenliste freunde = new Personenliste();
            freunde.AddSorted("Claudia");
            freunde.AddSorted("Berta");
            freunde.AddSorted("Anton");
            //freunde.DeleteByName("Anton");
            freunde.PrintReverse();
        }
    }
}
