﻿using System;
using System.Linq.Expressions;

namespace _03VererbungKfzIntro
{
    //Kraftfahrzeuge:
    //
    //Steuerberechnung PKW:
    //Hubraumsteuer
    //Den Anteil für den Hubraum berechnen Sie dabei anhand der von der Motorenart abhängigen Hubraumsteuer:

    //Motorenart Steuern pro angefangenen 100 Kubikzentimetern Hubraum
    //Benzin- / Ottomotor	2,00 Euro
    //Dieselmotor 9,50 Euro
    //Datenquelle: Bundesfinanzministerium

    //Ein Dieselfahrzeug mit einem Motorhubraum von 1.500 ccm kostet folglich 142,50 Euro Hubraumsteuer.

    //CO2-Steuer
    //Zusätzlich wird die Steuer für den CO2-Ausstoß berechnet. Jedes Gramm CO2-Ausstoß pro Kilometer, das über 
    //dem Sockelwert liegt, kostet zwei Euro Steuern. Die Sockelwerte – „Freibeträge“ für unterschiedliche 
    //Zeitpunkte der Erstzulassung – können Sie der folgenden Tabelle entnehmen ...
    //----------

    // Steuerberechnung Motorrad
    // Wie hoch ist die Steuer für Krafträder über 125 ccm?
    // Je angefangene 25 ccm Hubraum müssen Sie jährlich eine Kfz-Steuer von 1,84 Euro entrichten.
    //
    // Steuerberechnung LKW
    //Ein Lkw unterliegt der Kraftfahrzeugsteuer und muss besteuert werden
    //Beim Lkw wird eine Steuer über Gewicht und andere Bedingungen erhoben
    //Lkw-Steuer richtet sich auch nach Schadstoffklassen und Geräuschklassen
    //Der Höchstsatz für die günstigste Lkw-Steuerklasse beträgt 556,00 Euro
    class Kfz 
    {
        /* private */static int kfzZaehler = 0;
        public string kennzeichen { get; private set; }   // private ist die default-Einstellung
        // public ~ alle Methoden aus allen Klassen dürfen darauf zugreifen
        // private ~ ausschließlich die Methoden aus dieser Klasse dürfen hierauf zugreifen
        // protected ~ die Methoden aus dieser Klasse UND die Methoden aus abgeleiteten Klassen dürfen
        //              auf dieses Property zugreifen; Methoden aus anderen Klassen nicht!
        public Kfz(string kennzeichen) { this.kennzeichen = kennzeichen; }
        public virtual void Ausgeben() { Console.Write($"{kennzeichen}:  "); }
        public virtual double SteuernBerechnen() { return -999; }
        // virtual ~ 
        //   1. Methodenauswahl auf Basis des DYNAMISCHEN Objekttyps (z.B. Pkw.SteuernBerechnen() )
        //   2. Diese Methode KANN in der abgeleiteten Klasse überschrieben werden; muss aber nicht!
        //   Beispiel für virtual: public virtual string ToString() { return "namespacename.klassenname"; }
        // abstract ~
        //   1. wie oben
        //   2. Diese Methode MUSS in der abgeleiteten Klasse überschrieben werden
        //   3. Von einer abstrakten Klasse können keine Objekte angelegt werden
    }
    class Pkw : Kfz     // Vererbung, Spezialisierung, ist-ein Beziehung
    {
        protected int hubraum, CO2;
        public enum BenzinDiesel { Benzin, Diesel };
        BenzinDiesel typ;
        public Pkw(string kennzeichen, int hubraum, int CO2, BenzinDiesel typ) : base(kennzeichen)
        {
            this.hubraum = hubraum;
            this.CO2 = CO2;
            this.typ = typ;
        }
        public override double SteuernBerechnen()
        {
            if (typ == BenzinDiesel.Benzin)
                return 2.0 * (hubraum + 99) / 100;
            else
                return 9.5 * (hubraum + 99) / 100;
        }
        public override void Ausgeben()
        {
            base.Ausgeben();
            Console.WriteLine($"{typ}, Hubraum: {hubraum}");
        }
    }
    class Oldtimer : Pkw
    {
        int baujahr;
        public Oldtimer(string kennzeichen, int hubraum, int CO2, BenzinDiesel typ, int baujahr)
            : base (kennzeichen,hubraum,CO2,typ)
        {
            this.baujahr = baujahr;
        }
        public override double SteuernBerechnen()=> 1.0 * (hubraum + 99) / 100;
        public override void Ausgeben()
        {
            base.Ausgeben();
            Console.WriteLine($"Baujahr: {baujahr}");
        }
    }
    class Motorrad : Kfz
    {
        int hubraum;
        public Motorrad(string kennzeichen, int hubraum) : base(kennzeichen)
        {
            this.hubraum = hubraum;
        }
        public override double SteuernBerechnen() => 1.84 * (hubraum + 24) / 25;
    }
    class LKW : Kfz
    {
        int hubraum, gewicht;
        public LKW(string kennzeichen, int hubraum, int gewicht) : base(kennzeichen)
        {
            this.hubraum = hubraum;
            this.gewicht = gewicht;
        }
        public override double SteuernBerechnen() => 1000;
    }
    //class Elektroroller : Kfz { }
    class Program
    {
        static void Main(string[] args)
        {
            #region Alte Vorgehensweise
            //Pkw[] autos = new Pkw[1000];
            //Motorrad[] motorraeder = new Motorrad[1000];
            //LKW[] lastwagen = new LKW[1000];
            //Elektroroller[]
            #endregion
            Kfz[] fahrzeuge = new Kfz[4];
            // Statischer Typ ~ Der angegebene Datentyp; hier Kfz
            // Der dynamische Typ ist der beim new() angegebene Typ

            #region Alte Vorgehensweise
            //int menueauswahl = 1, FzAnzahl = 0;
            //if (menueauswahl == 1)
            //    autos[autoanzahl] = new Pkw();
            //else if (menueauswahl == 2)
            //    motorraeder[motorradanzahl] = new Motorrad();
            //else if (menueauswahl == 3)
            //    lastwagen[lkwanzahl] = new LKW();
            #endregion

            fahrzeuge[0] = new Pkw("N-XY 567", 1598, 148, Pkw.BenzinDiesel.Diesel);
            fahrzeuge[1] = new Motorrad("ER-KW 123", 250);
            fahrzeuge[2] = new LKW("FÜ-KL 987", 4598, 3500);
            fahrzeuge[3] = new Oldtimer("N-AB 123",1998, 250, Pkw.BenzinDiesel.Benzin, 1960);

            #region Gemeinsames Feld, aber mit lästiger Typprüfung und Verzweigung
            // Der statische Typ zwingt zu einer Überprüfung des Typs, einem cast zum 
            // spezifischen Typ (z.B. PKW) und erst dann kann die spezifische Steuern-Methode aufgerufen werden
            //for (int i = 0; i < fahrzeuge.Length; i++)
            //{
            //    if (fahrzeuge[i] is Pkw)
            //        Console.WriteLine(((Pkw)fahrzeuge[i]).SteuernBerechnen());
            //    else if (fahrzeuge[i] is Motorrad)
            //        Console.WriteLine(((Motorrad)fahrzeuge[i]).SteuernBerechnen());
            //
            #endregion

            for (int i = 0; i < fahrzeuge.Length; i++)
            {
                Console.WriteLine($"{fahrzeuge[i].kennzeichen}: {fahrzeuge[i].SteuernBerechnen()}");
                // Methodenauswahl findet "normalerweise" auf Basis des STATISCHEN TYPS statt!
                // virtual und abstract ermöglichen, die gemäß des DYNAMISCHEN TYPS gespeicherte Methode
                // automatisch aufzurufen - ohne dass eine Typüberprüfung, ein cast oder eine if-Auswahl
                // erfolgen muss. Weitere/spätere Klassen werden einfach in dieses Verfahren durch
                // Erben von Kfz "eingeklinkt"!
            }
            for (int i = 0; i < fahrzeuge.Length; i++)
            {
                if (fahrzeuge[i].kennzeichen == "ER-KW 123")
                    Console.WriteLine("Gefunden!");
            }
            #region Alte Vorgehensweise
            //for (int i = 0; i < autoanzahl; i++)
            //{
            //    autos[i].SteuernBerechnen();
            //}
            //for (int i = 0; i < motorradanzahl; i++)
            //{
            //    motorraeder[i].SteuernBerechnen();
            //}
            #endregion
        }
    }
}
