﻿using System;

namespace _05_UebgDi_Warenwirtschaft
{
    // Programmieren Sie ein rudimentäres System zur Verwaltung beliebiger Produkte
    // Jedes Produkt soll die folgenden Eigenschaften besitzen, 
    //      int stueckzahl, double preis, string name
    // Es soll eigene (abstract oder nicht-abstract) Klassen für einzelne Produkte mit individuellen Datenfeldern geben: 
    // - Metallwaren mit den Unterklassen Schrauben und Nägel
    // - Milchprodukte mit den Unterklassen Joghurt und Butter 
    // - Gartenprodukte mit den Unterklassen Pflanzen und Container; Schreiben Sie für die Pflanze eine besondere
    //         Methode, die nur Pflanzen haben.
    // Erstellen Sie diese Klassen/Unterklassen mit geeigneten Konstruktoren, Basisklassenaufrufen, usw.
    // Entscheiden Sie, wie Sie vererben wollen (virtual/abstract)
    // Geben Sie für jede Klasse - wo sinnvoll - eine Überschreibung der ToString()-Methode an
    // Legen Sie in Main() ein Feld mit einem Objekt je Klasse an, geben Sie alle Elemente in einer Schleife aus
    // und schreiben Sie eine Methode, die z.B. nach der Pflanze über den Namen sucht und dieses Objekt zurückliefert
    // Rufen Sie dann für die Pflanze diese besondere Methode auf.
    interface IBegiessbar
    {
        void Gießen();
    }
    abstract class Produkt
    {
        int stueckzahl;
        double preis;
        public string Name { get; protected set; }
        // private: Nur die Methoden dieser Klasse Produkt dürfen das set-Name aufrufen
        // protected: Die Methoden dieser Klasse Produkt und die Methoden der von Produkt
        // abgeleiteten Klassen dürfen set-Name aufrufen; gilt auch transitiv
        public Produkt(int stueckzahl, double preis, string name)
        {
            this.stueckzahl = stueckzahl;
            this.preis = preis;
            this.Name = name;
        }
        public double Wert() => preis * stueckzahl;

        //public abstract void Gießen();  -- passt nicht für alle Produkte (z.B. Möbel)
        //public virtual void Gießen() {} -- passt auch nicht, würde nachträgliches Erweitern der Basisklasse erfordern
        //      was nicht möglich ist, wenn die Basisklasse von einem anderen Hersteller stammt.
    }
    abstract class Gartenprodukte : Produkt
    {
        public Gartenprodukte(int stückzahl, double preis, string name)
            : base(stückzahl, preis, name) { }
    }
    class Pflanzen : Gartenprodukte, IBegiessbar
    {
        public enum Pflanzentyp { zier, nutz};
        Pflanzentyp typ;
        public Pflanzen(int stückzahl, double preis, string name, Pflanzentyp typ) 
            : base (stückzahl,preis,name)
        {
            this.typ = typ;
        }
        public void Gießen() { }
    }
    class Froesche : Produkt ,IBegiessbar
    {
        public Froesche(int stückzahl, double preis, string name)
            : base(stückzahl, preis, name) { }
        public void Gießen()
        {
            Console.WriteLine("Frosch wird begossen"); 
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            Produkt[] produkte = new Produkt[4];
            produkte[0] = new Pflanzen(10, 0.35, "Geranien", Pflanzen.Pflanzentyp.zier);
            produkte[1] = new Pflanzen(10, 0.55, "Salat", Pflanzen.Pflanzentyp.nutz);
            produkte[2] = new Froesche(100, 2.49, "Hopper");
            produkte[3] = new Pflanzen(10, 0.55, "Karotten", Pflanzen.Pflanzentyp.nutz);
            foreach (Produkt item in produkte)
            {
                #region Typkonvertierungen
                //if (item.Name == "Geranien")
                //{
                //    // item.Gießen();  -- Geht nicht, da der statische Typ die aufrufbaren Methoden def.

                //    ((Pflanzen) item).Gießen();
                //    // Typ-cast ~ item wird in eine Pflanzen-Referenz konvertiert. Falls dies nicht
                //    // möglich ist, wird eine Exception geworfen

                //    (item as Pflanzen).Gießen();
                //    Pflanzen p1 = item as Pflanzen;
                //    if (p1 != null)
                //        p1.Gießen();
                //    // as ~ versuche item in eine Pflanzen-Referenz zu konvertieren. Falls dies nicht
                //    // möglich ist, wird null zurückgegeben.

                //    if (item is Pflanzen) { }
                //    // Testet, ob item in Pflanzenreferenz konvertierbar ist => bool-Ergebnis
                //    if (item is Pflanzen p2)
                //        p2.Gießen();
                //    // Im Erfolgsfall befindet sich in p2 die Pflanzen-Referenz
                //}
                #endregion
                //if (item is Pflanzen p2)
                //    p2.Gießen();
                //if (item is Froesche f2)
                //    f2.Gießen();
                if (item is IBegiessbar it2)
                    it2.Gießen();

            }
        }
    }
}
