﻿using Microsoft.VisualBasic;
using System;
using System.Collections.Generic;
using System.Text;

// Erstellen Sie mit Hilfe einer Liste einen generischen Stapel (Stack), in dem beliebige Elemente
// gespeichert werden können.
// Ein Stack ist eine Datenstruktur, ähnlich wie ein Stapel auf Ihrem Schreibtisch. Das, was 
// zuoberst aufliegt, wird auch zuerst wieder heruntergenommen.
// Sie können einen Stapel leicht mithilfe einer Liste aufbauen. Hierfür benötigen Sie folgenden Methoden:
// - AddFirst: Als erstes Element einfügen
// - GetFirst(bool removeFromStack=true): Liefert das erste Element zurück und entfernt es vom Stapel; kann 
//            per removeFromStack unterbunden werden
// - Contains(T): Sucht nach dem übergebenen Element und liefert true/false zurück
// - GetEnumerator() : Ermöglicht einen Durchlauf durch den Stapel und liefert nach und nach alle Elemente zurück



namespace _06_UebgSaGenerics
{
    class GenericStack <T>
    {
        private class Element  // Element ist eine private Hilfsklasse der Klasse StringListe
        {
            public T obj;
            public Element next = null;
            public Element(T daten) { this.obj = daten; }
            public override string ToString() => obj.ToString();
        }

        Element anf = null, ende = null;
        int anz = 0;      // Sehr sinnvoll für Index-Ops
                          //public StringListe() { }

        public void AddFirst(T daten)
        {
            // 1. Leere Liste
            // 2. Es existiert mind. ein Element
            Element neuesElement = new Element(daten);   // Neues Element anlegen
            anz++;
            if (anf == null)                            // 1.Fall: Leere Liste?
                anf = ende = neuesElement;
            else
            {
                neuesElement.next = anf;                // 2. Fall
                anf = neuesElement;
            }
        }
        public T GetFirst(bool removeFromStack = true)
        {
            if (anf == null) throw new Exception("Stapel ist leer");

            T zwischen = anf.obj;
            if (removeFromStack == true) anf = anf.next;
            return zwischen;
        }
        


    }
}
