﻿using System;
using System.Threading;

namespace _06Exceptions_Threads
{
    public class ServerClass
    {

        static int count = 0;
        // The method that will be called when the thread is started.
        public void InstanceMethod()
        {
            int processNr = count++;
            try
            {
                Console.WriteLine("   InstanceMethod läuft in einem eigenen Thread");

                // Pause for a moment to provide a delay to make
                // threads more apparent.
                if (processNr == 3)
                {
                    Thread.Sleep(2000);
                    throw new NullReferenceException("Null Referenz!!!");
                }
                else
                    Thread.Sleep(3000);
            }
            catch (Exception e)
            {
                Console.WriteLine($"!!!Fehler {e.Message} in Instanz {processNr}");
            }
            finally
            {
                Console.WriteLine($"   Thread {processNr} wurde beendet");
            }
        }
    }

    public class Simple
    {
        public static void Main()
        {
            try
            {
                for (int i = 0; i < 10; i++)
                    CreateThreads();
                Console.WriteLine("Alle Threads gestartet!");
            }
            catch (Exception e)
            {
                Console.WriteLine($"Fehler: {e.Message}");
            }
            Console.WriteLine("Main() Ende");
        }
        public static void CreateThreads()
        {
            ServerClass serverObject = new ServerClass();

            Thread InstanceCaller = new Thread(new ThreadStart(serverObject.InstanceMethod));
            InstanceCaller.Start();  // Start the thread.

            Console.WriteLine("Ein neuer Thread wurde aus Main() gestartet");
        }
    }
}
