﻿using System;

namespace _06GenericList
{
    class Person : IComparable<Person>
    {
        public string name, vorname;
        public Person(string name, string vorname)
        {
            this.name = name;
            this.vorname = vorname;
        }
        public int CompareTo(Person other)
        {
            return (name + vorname).CompareTo(other.name + other.vorname);
        }
        public override string ToString()
        => $"{name}, {vorname}";
    }
    class Program
    {
        static bool IstGerade(uint z)
        {
            return z % 2 == 0;
        }

        private static string pattern;
        static bool Namenstest(Person x)
        {
            return x.name.Contains(pattern) && 
                (x.vorname.Contains("e") || x.vorname.Contains("E"));
        }
        static void Main(string[] args)
        {
            Liste<uint> il = new Liste<uint>();
            il.AddEnd(10);
            il.AddEnd(20);
            il.AddEnd(23);
            il.AddEnd(21);
            il.AddEnd(35);
            il.AddEnd(40);
            //foreach (var item in il.Filter(x => x % 2 == 0))    
            foreach (var item in il.Filter(IstGerade))    // T => bool
            {
                Console.WriteLine(item);
            }
            //il.Print();

            Console.WriteLine("*****************");
            Liste<string> sl = new Liste<string>();
            sl.AddSorted("Emil");
            sl.AddSorted("Anton");
            sl.AddSorted("Berta");
            sl.AddSorted("Bertram");
            sl.AddSorted("Dieter");
            foreach (var item in sl.Filter(x=>x.StartsWith("Ber")))
            {
                Console.WriteLine(item);
            }
            Console.WriteLine("*****************");
            //sl.Print();

            Liste<Person> pl = new Liste<Person>();
            pl.AddSorted(new Person("Meier", "Emil"));
            pl.AddSorted(new Person("Schmitt", "Anton"));
            pl.AddSorted(new Person("Huber", "Dieter"));
            pl.AddSorted(new Person("Müller", "Berta"));
            //foreach (var item in pl.Filter(x => x.name.Contains("er")&&(x.vorname.Contains("e")||x.vorname.Contains("E"))))
            //foreach (var item in pl.Filter(x => x.name.Length<6 && x.vorname.Contains("er")))
            pattern = "er";
            foreach (var item in pl.Filter(Namenstest))
            {
                Console.WriteLine(item);
            }

            //pl.Print();

            //Liste<Liste<Person>> pll = new Liste<Liste<Person>>();
            //pll.AddSorted(pl);
        }

    }
}
