﻿using Microsoft.VisualBasic.CompilerServices;
using System;
using System.Diagnostics.CodeAnalysis;
using System.Security.Cryptography;

namespace _06GenericsIntro
{
    class Program
    {
        class Person : IComparable<Person>
        {
            string name, vorname;

            public int CompareTo(Person other)
            {
                return (name+vorname).CompareTo(other.name+other.vorname);
            }

            //public int CompareTo(object obj)
            //{
            //    return name.CompareTo(((Person)obj).name);
            //}
        }
        static T Max<T>(T a, T b) where T : IComparable<T>
        {
            return b.CompareTo(a) > 0 ? b : a;
            // p1.CompareTo(p2)
        }
        static int MaxFeld<T>(T[] f) where T:IComparable<T>
        {
            int max = 0;
            for (int i = 1; i < f.Length; i++)
            {
                if (f[i].CompareTo(f[max]) > 0)
                    max = i;
            }
            return max;
        }
        
        static void Main(string[] args)
        {
            Console.WriteLine(1.CompareTo(3));
            Console.WriteLine(1.5.CompareTo(3.14));

            Console.WriteLine(Max(1, 2.5));
            Console.WriteLine(Max<int>(1, 2));
            Console.WriteLine(Max(1, 3));
            Person p1 = new Person();
            Person p2 = new Person();
            //Console.WriteLine(Max(p1,p2));
            int[] feld = { 3, 5, 6, 9, 10, 12 };
            string[] namen = { "Anton", "Dieter", "Emil", "Berta" };
            Console.WriteLine(MaxFeld(feld));
            Console.WriteLine(MaxFeld(namen));
        }
    }
}
