﻿using System;
using System.Collections.Generic;

namespace _07_MethodeSplitArray
{
    class Kfz : IComparable <Kfz>
    {
        string kennzeichen;
        public Kfz(string kennzeichen) { this.kennzeichen = kennzeichen; }
        public int CompareTo(Kfz other) => kennzeichen.CompareTo(other.kennzeichen);
    }
    class Program
    {
        //static int[] SplitArray(int limit, int[] f)
        static U[] SplitArray<U>(U limit, params U[] f) 
            where U:IComparable<U>  // ~Constraint
            // ~Vertrag: SplitArray kann Felder von jedem Typ bearbeiten,
            //     der eine CompareTo-Methode enthält
        {
            List<U> erg = new List<U>();
            foreach (var item in f)
            {
                if (item.CompareTo(limit) > 0)
                    erg.Add( item);
            }
            return erg.ToArray();
        }
        static int MyCompareTo(string s1, string s2)  // "Hallo" | "Hallo2"
        {
            int limit = s1.Length < s2.Length ? s1.Length : s2.Length;
            for (int i = 0; i < limit; i++)
            {
                int dif = s1[i] - s2[i];
                if (dif != 0)
                    return dif;
            }
            return s1.Length - s2.Length;
        }
        static void Main(string[] args)
        {
            int[] f1 = SplitArray(3, 1, 3, 5, 7, 9, 11);
            string[] f2 = SplitArray("Claudia", "Anton","Berta","Dieter","Emil");
            Kfz[] f3 = SplitArray(new Kfz("N-AB 100"), 
                new Kfz("N-XY 300"),new Kfz("AB-MN 200"), new Kfz("ER-S 500"));
            foreach (var item in f3)
            {
                Console.WriteLine(item);
            }

        }
    }
}
