﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace _06InterfaceStack
{
    class ListStack<T> : IStack<T>
    {
        class LItem
        {
            public T data;
            public LItem next;
            public LItem(T Data) { data = Data; }
        }
        LItem first;
        int count = 0;
        public void Push(T Data)
        {
            LItem neu = new LItem(Data);
            neu.next = first;
            first = neu;
            count++;
        }
        public T Pop()
        {
            if (first == null)
                throw new Exception("Stack leer!");
            T ret = first.data;
            first = first.next;
            count--;
            return ret;
        }
        public int Count => count;
    }

    class ArrayStack<T> : IStack<T>
    {
        T[] data = new T[100];
        int count = 0;
        public void Push(T data)
        {
            this.data[count] = data;
            count++;
        }
        public T Pop()
        {
            if (count == 0)
                throw new Exception("Stack leer!");
            count--;
            return data[count];
        }
        public int Count => count;
        //public int Count { get { return count; } }
    }



    interface IStack<T>
    {
        void Push(T Data);
        T Pop();
        int Count { get; }
    }









    
    class Program
    {
        static void Main(string[] args)
        {
            IStack<string> stack1 = new ArrayStack<string>();
            //IStack<string> stack1 = new ListStack<string>();
            //IStack<string> stack1 = new IStack<string>();
            //  Nicht zulässig, da IStack<> eine abstrakte Klasse ist!
            stack1.Push("Anton");
            stack1.Push("Berta");
            stack1.Push("Claudia");

            while (stack1.Count > 0)
                Console.WriteLine(stack1.Pop());
        }
    }
}
