﻿using System;
using System.Collections.Generic;

namespace _08_DelegateAnwendungen
{
    class Program
    {
        delegate T MeineFkt<T>(T x);   // T=int --> int-Parameter & int-Ergebnis
        //delegate bool Predicate<T>(T x);
        //delegate void Action<T>(T x);
        //delegate void Action();
        static T[] ApplyAll<T>(MeineFkt<T> fkt, params T[] werte)
        {
            T[] erg = new T[werte.Length];
            Console.Write("APPLY ALL: ");
            for (int i = 0; i < werte.Length; i++)
            {
                erg[i] = fkt(werte[i]);
                Console.Write ($"{erg[i]}  "); 
            }
            Console.WriteLine();
            return erg;
        }
        static T[] Select<T>(Predicate<T> filter, params T[] werte)
        {
            Console.Write("SELECT: ");
            List<T> erg = new List<T>();
            foreach (var item in werte)
            {
                if (filter(item))
                {
                    erg.Add(item);
                    Console.Write($"{item}  ");
                }
            }
            Console.WriteLine();
            return erg.ToArray();
        }
        static int Quadrieren(int x) => x * x;

        static void Main(string[] args)
        {
            ApplyAll(x => (int) (x * 1.02), 10, 30, 40, 50, 60, 70, 80, 100);
            ApplyAll(x => x + 1, 10, 30, 40, 50, 60, 70, 80, 100);
            ApplyAll(x => x * 2, 10, 30, 40, 50, 60, 70, 80, 100);
            ApplyAll(Quadrieren, 10, 30, 40, 50, 60, 70, 80, 100);
            Console.WriteLine("----------");

            string[] namen = { "Anton", "Berta", "Claudia", "Emil", "Dieter" };
            ApplyAll(x => x.ToUpper(), namen);
            Console.WriteLine("----------");
            Select (x => x.Contains("E"), ApplyAll(x => x.ToUpper(), namen));
            Console.WriteLine("----------");
            Select(x => x > 100, ApplyAll(x => x * 2, 10, 30, 40, 50, 60, 70, 80, 100));

            Console.WriteLine("----------");
            Select(x => x % 15 == 0, 10, 20, 30, 40, 50, 60, 70, 80);
            Select(x => x.Contains("au"),
                Select(x => x.StartsWith("C"), "Berta", "Claudia", "Cornelia", "Dieter"));

            Select(x => true, 10, 20, 30, 40, 50, 60, 70, 80);

            Select (x=> x > 5 && x < 18, Select(x => x % 2 == 0 , 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20));

        }
    }
}
