﻿using System;

namespace _08Button
{
    
    class Button
    {
        public delegate void OnMouseClick();
        string beschriftung;
        public event OnMouseClick onMouseClick;
        // Event ist eine Einschränkung der Delegates:
        // (1) INNERHALB der Klasse, in der die Event-Variable angelegt ist, gibt es keine
        // Einschränkungen ( =null, =Funktion, ?.Invoke() ) sind ohne Einschränkungen erlaubt
        // 
        // (2) AUßERHALB der Klassse gelten die folgenden Einschränkungen:
        // a) Nur noch += und -=   , Kein =null und kein =Funktion
        // b) Kein direkter event-Aufruf, Aufruf muss über eine Methode der Klasse erfolgen

        public Button(string beschriftung) { this.beschriftung = beschriftung; }
        public void EreignisAusfuehren()   // wird aufgerufen, wenn der Button angeklickt wird
        {
            //if (onMouseClick != null)
            //    onMouseClick();
            onMouseClick?.Invoke();
            //objVar?.Methodenaufruf()  -- Methode wird nur aufgerufen, wenn objVar != null ist
        }
    }
    // Firma A

    // --------------------------------------------------

    // Ab hier Firma B
    class Program
    {
        static void BerechneWert()
        {
            Console.WriteLine("Wertberechnung wurde aufgerufen");
        }
        static void NochEineBerechnung()
        {
            Console.WriteLine("Noch eine Berechnung");
        }
        static void Main(string[] args)
        {
            Button b1 = new Button("Berechnen");
            b1.onMouseClick += BerechneWert;
            b1.onMouseClick += NochEineBerechnung;

            b1.onMouseClick = BerechneWert;  // Bei Event ist die direkte Zuweisung nicht erlaubt, nur += und -=

            b1.EreignisAusfuehren();  // Annahme: Es wurde auf der Oberfläche der Button angeklickt
            b1.onMouseClick?.Invoke();    // Bei Event ist der direkte Aufruf nicht erlaubt, 
                                            // nur über eine Methode der Klasse
        }
    }
}
