﻿using System;

namespace _08DelegateIntro
{
    class Program
    {
        // Firma-A hat dieses Programm erstellt
        delegate double MyFunction(double x);
        static void Wertetabelle(double von, double bis, MyFunction funktion)
        {
            for (double x = von; x <= bis; x += 1)
                Console.WriteLine($"{x,6:f2} | {funktion(x),10:f4}");
            Console.WriteLine("-------------------");
        }
        // funktion ist eine Variable, die eine Referenz auf eine Funktion übergeben bekommt

        static MyFunction funkt;  // funkt ist am Anfang = null
        static void Wertetabelle2(double von, double bis)
        {
            for (double x = von; x <= bis; x += 1)
                Console.WriteLine($"{x,6:f2} | {funkt(x),10:f4}");
            Console.WriteLine("-------------------");
        }
        // Firma-B möchte es verwenden UND MODIFIZIEREN
        static double MeinQuadrieren(double xx)
        {
            return xx * xx;
        }
        static double ZweiX(double x) => 2 * x;
        static void Main(string[] args)
        {
            Wertetabelle(1, 4, Math.Sin);
            Wertetabelle(1, 3, MeinQuadrieren);
            Wertetabelle(1, 3, ZweiX);
            Wertetabelle(1, 3, delegate (double a) { return 3 * a; });
            Wertetabelle(1, 3, b => 4 * b);


            funkt = MeinQuadrieren;
            funkt += Math.Sin;
            funkt += delegate (double a) { return 3 * a; };
            funkt += b => 4 * b;
            //Wertetabelle2(1, 3);
            Console.WriteLine($"Ergebnis von funkt(5): {funkt(5)}");
        }
    }
}
