﻿using System;

namespace _08MulticastDelegate
{
    delegate void MeinDelegate(string s);
    
    class TestClass
    {
        public enum Ampelfarben { rot, gelb, grün };
        // Define two methods that have the same signature as CustomDel.
        static void Hello(string s)
        {
            Console.WriteLine($"  Hello, {s}!");
        }

        static void Goodbye(string s)
        {
            Console.WriteLine($"  Goodbye, {s}!");
        }

        static void TueEtwas(string s)
        {
            Console.WriteLine($"  Hier wird gerechnet, {s}!");
        }


        static void Main()
        {
            // Declare instances of the custom delegate.
            // MeinDelegate hiDel, byeDel, multiDel, multiMinusHiDel;

            // In this example, you can omit the custom delegate if you
            // want to and use Action<string> instead.
            Action<string> hiDel, byeDel, multiDel, multiMinusHiDel;

            hiDel = Hello;
            byeDel = Goodbye;

            // The two delegates, hiDel and byeDel, are combined to
            // form multiDel.
            // multicast-Delegate
            multiDel = hiDel;
            multiDel += TueEtwas;
            multiDel += byeDel;

            // Remove hiDel from the multicast delegate, leaving byeDel,
            // which calls only the method Goodbye.
            multiMinusHiDel = multiDel;
            multiMinusHiDel -= hiDel;
            multiDel += multiMinusHiDel;
            Console.WriteLine("Aufruf des Delegates hiDel:");
            hiDel("A");
            Console.WriteLine("Aufruf des Delegates byeDel:");
            byeDel("B");

            Console.WriteLine("Aufruf des Delegates multiDel:");
            multiDel("C");
            Console.WriteLine("Aufruf des Delegates multiMinusHiDel:");
            multiMinusHiDel("D");
            Console.WriteLine("Aufruf des modifizierten Delegates multiDel:");
            multiDel("E");

        }
    }
}
