﻿using System;

namespace _09_UebgMailVerteilung
{
    public delegate void Callback(string s);
    // Delegate definiert einen neuen Typ
    class MailServer
    {
        /* ToDo: Delegate/Event anlegen */
        public event Callback verteiler;
        // Event ~ ein eingeschränktes Delegate
        // = ist nicht mehr erlaubt, nur noch += und -=
        // Event-Aufruf ist nur noch Methoden derjenigen Klasse erlaubt,
        // in der sich die Delegate-Var. befindet

        public void Senden(string s)
        {
            /* ToDo: Aufruf des verteilers */
            Console.WriteLine("--- Start von Senden ---");
            //if (verteiler != null)
            //    verteiler(s);
            verteiler?.Invoke(s);
            Console.WriteLine("--- Ende von Senden  ---");
            Console.WriteLine();
        }
    }

    // Bis hierher: Code der Firma A

    class FirmaB
    {
        public static string Gespeichert { get; private set; }
        public static void Speichern(string s) { Gespeichert = s; }
        public void FirmaBMoechteInformiertWerden(string s)
        {
            Console.WriteLine($"Firma B: {s}");
        }
    }
    class FirmaC
    {
        string mitarbeiter;
        public FirmaC(string name) { mitarbeiter = name; }
        public void FirmaCInfo(string s)
        {
            Console.WriteLine($"Firma C-{mitarbeiter}: {s}");
        }
    }

    // Ab hier: Code der Firma B
    class Program
    {
        static void AllesInGrossbuchstaben(string s)
        {
            Console.WriteLine(s.ToUpper());
        }
        static void Main(string[] argv)
        {
            MailServer mb = new MailServer();

            FirmaB fb = new FirmaB();
            FirmaC fc1 = new FirmaC("Anton");
            FirmaC fc2 = new FirmaC("Berta");

            /* ToDos:
             * Geben Sie mindestens zwei geeignete CallBack-Methoden an
             * Rufen Sie den Mail-Verteiler mit Beispieltexten auf
             * Verwenden Sie bei den CallBack-Methoden auch Methoden aus anderen Klassen als Program
             * Nehmen Sie eine Rückruf-Methode wieder aus dem Mailverteiler heraus
             * Geben Sie noch eine Nachricht aus
             */


            mb.verteiler += Console.WriteLine;     // Einspeichern/Registrieren der Objekt+Methodenreferenz
            mb.verteiler += AllesInGrossbuchstaben;
            mb.verteiler += FirmaB.Speichern;       // statische Methode einer anderen Klasse: Klassenname+Punkt+Methodenname
            mb.verteiler += fc1.FirmaCInfo; // nicht-statische Methode: obj+Methodenname
            mb.verteiler += fc2.FirmaCInfo;

            // mb.verteiler = null; -- Bei event-Delegates nicht erlaubt
            mb.Senden("Geheime Nachricht");           // wird an alle registrierten Empfänger gesendet
            Console.WriteLine("In Firma B gespeichert: " + FirmaB.Gespeichert);
            mb.Senden("Ein schönen guten Morgen");
            Console.WriteLine("In Firma B gespeichert: " + FirmaB.Gespeichert);            
        }
    }
}
