﻿using System;
using System.Linq;

namespace _10_Erweiterungsmethoden
{
    public static class IntExt
    {
        /// <summary>
        /// Beispiel für eine Erweiterungsfunktion, hier für den Typ int
        /// Beachten Sie bitte, den Einsatz von "this" in der Spezifizierung des Parametertyps
        /// Für Erweiterungsmethoden muss die Klasse und die Methode static 
        /// deklariert sein und vor dem Parameter, der ja später durch das
        /// Objekt ersetzt werden soll, muss ein THIS stehen!
        /// </summary>
        public static int Abs(this int i)
        { return (i > 0) ? i : -i; }

        public static T[] Sortieren<T>(this T[] iFeld)
        {
            Array.Sort(iFeld);
            return iFeld;
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            int ix = -25;
            Console.WriteLine(ix.Abs());

            int[] ints = { 10, 45, 15, 39, 21, 26 };
            //var result = ints.OrderBy(g => -g);
            var result = ints.Sortieren();
            foreach (var i in result)
            {
                Console.Write(i + " ");
            }
            Console.WriteLine();
        }
    }
}
