﻿using System;


namespace _10_NewVsOverrideSchach
{
    /*
     * Das Interface Bewertung schreibt eine Eigenschaft (Property) vor, die vom Typ String ist 
       und einen öffentlichen Getter und einen öffentlichen Setter besitzen muss.
        Für die Vererbung gilt.
        •	Jedes Spiel hat eine Methode Play, die keine Parameter übergeben bekommt und void zurückgibt. 
        •	Die Methode Play in den Klassen Spiel und Brettspiel darf keine Implementierung besitzen.
        •	Die Methode Play in Fussball gibt „Rennen“ auf der Console aus.
        •	Die Methode Play in FussballUebertragung ist eine neue Methode Play, die nichts mit der 
            Methode Play aus Spiel zu tun hat und „schauen“ auf der Console ausgibt.
        •	Die Methode Play des Brettspiels gibt „spielen“ auf der Console aus.
        •	Die Klasse Brettspiel muss die Eigenschaft des Interfaces so implementieren, dass es in 
            späteren Klassen überschrieben werden kann.
        •	Schach erbt nur.
        Implementieren Sie die Klassen-Hierarchie und das Interface.
    */

    class Program
    {
        abstract class Spiel
        {              
            public abstract void Play();    
        }

        class Fussball : Spiel
        {  
            public override void Play()
            {
                Console.WriteLine("rennen");            	
            }
        }

        class FussballUebertragung : Fussball
        {  
            public new virtual void Play()
            { 
                Console.WriteLine("schauen");
            }
        }
        class FussballUebertragungZDF : FussballUebertragung
        {
            public override void Play()
            {
                Console.WriteLine("schauen, nur besser ohne Ton");
            }
        }
        abstract class Brettspiel : Spiel, IBewertung
        {   
            public virtual String Bewertung { get; set; }  
            public override void Play()
            {
                Console.WriteLine("spielen");
            }
        }

        class Schach : Brettspiel
        {       
                
        }


        interface IBewertung
        {
            string Bewertung { get; set; }
        }

        static void Main(string[] args)
        {
            Fussball f = new Fussball();
            Console.Write($"{"Fussball",45}: "); f.Play();
            FussballUebertragung fu = new FussballUebertragung();
            Console.Write($"{"Fussballübertragung",45}: "); fu.Play();
            Fussball f2 = fu;
            Console.Write($"{"Fussball/Fussballübertragung",45}: "); f2.Play();
            Spiel spF = f;
            Console.Write($"{"Spiel/Fussball",45}: "); spF.Play();
            Spiel spFu = fu;
            Console.Write($"{"Spiel/Fussballübertragung",45}: "); spFu.Play();
            Console.WriteLine();

            FussballUebertragungZDF zdf = new FussballUebertragungZDF();
            Console.Write($"{"FussballübertragungZDF",45}: "); zdf.Play();
            FussballUebertragung fu2 = zdf;
            Console.Write($"{"Fussballübertr/FussballübertragungZDF",45}: "); fu2.Play();
            Console.WriteLine();

            Schach s1 = new Schach();
            Console.Write($"{"Schach",45}: "); s1.Play();
            Brettspiel br1 = s1;
            Console.Write($"{"Brettspiel/Schach",45}: "); br1.Play(); 
            Spiel spB1 = s1;
            Console.Write($"{"Spiel/Schach",45}: "); spB1.Play();
        }
    }
}
