﻿using System;

namespace _10_OverrideVsNew
{
    //Nehmen wir an, dass die Firma A eine Klasse mit dem Namen GraphicsClass erstellt, 
    //die Ihr Programm benutzt.Die folgende Datei ist GraphicsClass:

    class GraphicsClass
    {
        public virtual void DrawLine() { }
        public virtual void DrawPoint() { }
    }

    //Ihr Unternehmen verwendet diese Klasse, und Sie verwenden sie zum 
    //Ableiten einer Klasse oder zum Hinzufügen einer neuen Methode:

    class YourDerivedGraphicsClass : GraphicsClass
    {
        public void DrawRectangle() { }
    }

    // Ihre Anwendung wird ohne Probleme laufen, bis Firma A eine neue Version 
    // von GraphicsClass herausgibt, die dem folgenden Code ähnelt:

    class GraphicsClass
    {
        public virtual void DrawLine() { }
        public virtual void DrawPoint() { }
        public virtual void DrawRectangle() { }
    }
    //Die neue Version von GraphicsClass enthält jetzt eine Methode namens DrawRectangle.
    class YourDerivedGraphicsClass : GraphicsClass
    {
        public override void DrawRectangle() { }
    }
    // Das Schlüsselwort override stellt sicher, dass alle Objekte, die von YourDerivedGraphicsClass 
    // abgeleitet sind, die Version von DrawRectangle der abgeleiteten Klasse verwenden.
    // Objekte, die von YourDerivedGraphicsClass abgeleitet sind, können auf die Basisklassenversion 
    // von DrawRectangle mithilfe des base-Schlüsselworts zugreifen:
    // base.DrawRectangle();
    //
    // Wenn Sie nicht möchten, dass Ihre Methode die neue Basisklassenmethode außer Kraft setzt, 
    // gelten die folgenden Überlegungen.Sie können Ihre Methode umbenennen, um Verwechslungen 
    // zwischen den beiden Methoden zu vermeiden.Dies kann zeitaufwändig und fehleranfällig sein 
    // und ist in einigen Fällen einfach nicht praktikabel.

    // Alternativ können Sie die Warnung vermeiden, indem Sie in der Definition Ihrer 
    // abgeleiteten Klasse das Schlüsselwort new verwenden:

    class YourDerivedGraphicsClass : GraphicsClass
    {
        public new void DrawRectangle() { }
    }
    // Mit dem Schlüsselwort new wird dem Compiler mitgeteilt, dass Ihre Definition die Basisklassen-Definition 
    // ausblendet.Dies ist das Standardverhalten.
}
