﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace _11BinTreePersVerwaltung2
{
    abstract class Personal : IComparable<Personal>
    {
        protected string name;
        public Personal(string Name) { name = Name; }
        abstract public double Kosten { get; }
        public string Name
        {
            get { return name; }
        }
        public int CompareTo(Personal p2) { return name.CompareTo(p2.name); }
    }

    class Mitarbeiter : Personal
    {
        protected double gehalt;
        public Mitarbeiter(string Name, double Gehalt) : base(Name)
        {
            gehalt = Gehalt;
        }
        public override double Kosten
        {
            get { return 12.65 * gehalt; }
        }
    }

    class Führungskraft : Personal
    {
        protected double gehalt;
        protected double erfolgsbeteiligung;
        public Führungskraft(string Name, double Gehalt, double Erfolgsbeteiligung) : base(Name)
        {
            gehalt = Gehalt;
            erfolgsbeteiligung = Erfolgsbeteiligung;
        }
        public override double Kosten
        {
            get { return 12.65 * gehalt + erfolgsbeteiligung; }
        }
        public void Besonders() { }
    }

    class Werkvertragler : Personal
    {
        protected double betrag;
        public Werkvertragler(string Name, double Betrag) : base(Name)
        {
            betrag = Betrag;
        }
        public override double Kosten
        {
            get { return betrag; }
        }
    }
}
