﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace _11BinTreePersVerwaltung2
{
    class Program
    {
        static void InputData(BinTree<Personal> pt)
        {
            pt.Insert(new Mitarbeiter("Dieter", 2000));
            pt.Insert(new Führungskraft("Anton", 5000, 10000));
            pt.Insert(new Werkvertragler("Gustav", 12000));
            pt.Insert(new Mitarbeiter("Heiner", 2000));
            pt.Insert(new Werkvertragler("Berta", 10000));
            pt.Insert(new Werkvertragler("Ludwig", 12000));
            pt.Insert(new Mitarbeiter("Klaus", 2000));
            pt.Insert(new Mitarbeiter("Ida", 2000));
            pt.Insert(new Führungskraft("Charles", 5000, 10000));
            pt.Insert(new Werkvertragler("Johanna", 10000));
            pt.Insert(new Mitarbeiter("Emma", 2000));
            pt.Insert(new Mitarbeiter("Franz", 10000));
            pt.Insert(new Werkvertragler("Norbert", 10000));
            pt.Insert(new Werkvertragler("Willi", 10000));
            pt.Insert(new Mitarbeiter("Quasimodo", 2500));
            pt.Insert(new Führungskraft("Manni", 5200, 15000));
            pt.Insert(new Mitarbeiter("Otto", 10000));
            pt.Insert(new Werkvertragler("Uwe", 10000));
            pt.Insert(new Werkvertragler("Stefan", 10000));
            pt.Insert(new Mitarbeiter("Victoria", 2500));
            pt.Insert(new Mitarbeiter("Thorsten", 10000));
            pt.Insert(new Werkvertragler("Rainer", 10000));
            pt.Insert(new Werkvertragler("Zacharias", 10000));
            pt.Insert(new Mitarbeiter("Yvonne", 3000));
            pt.Insert(new Führungskraft("Volker", 5100, 10000));
            pt.Insert(new Mitarbeiter("Xaver", 2500));
        }
        static void Main(string[] args)
        {
            BinTree<Personal> persBaum = new BinTree<Personal>();
            InputData(persBaum);

            foreach (Personal p in persBaum)
                Console.WriteLine(p.Name + " " + p.GetType());
            Console.WriteLine();
            Console.WriteLine("-------------");

            var res = from Personal p in persBaum
                      where p is Führungskraft
                      orderby p.Kosten
                      select new { Name = p.Name.ToUpper(), Kosten = p.Kosten };
            Console.WriteLine("Führungskräfte: ");
            foreach (var p in res)
                Console.WriteLine(p);

            double FKosten = res.Sum(w => w.Kosten);
            Console.WriteLine("Kosten für die Führungskräfte: " + FKosten.ToString());
            int anz = res.Count();
            Console.WriteLine(anz + " Führungskräfte");

            var res2 = from Personal p in persBaum
                       where p.Kosten < 30000
                       orderby p.Kosten descending, p.Name descending  // Sortierung nach Kosten, dann Name
                       select new { Name = p.Name, K = p.Kosten };

            foreach (var p in res2)
                Console.WriteLine(p.Name + ": " + p.K.ToString());
        }
    }
}
