﻿using System;

namespace SS2020Test
{
    delegate void myDelegate(bool x);
    //delegate int myLogic(int x, int y);
    abstract class LogicElement
    {
        bool[] inputs;
        bool out1;
        string me;
        public LogicElement(int count, string me)
        {
            inputs = new bool[count];
            this.me = me;
            Update();
        }
        public event myDelegate Output;

        public abstract bool Logic(bool x, bool y);
        
        private void Input(int idx, bool val)
        {
            Console.Write($"<{me} = {val} | {out1} ");
            inputs[idx] = val;
            Update();
            Console.WriteLine($"--> {out1}>");
            Output?.Invoke(out1);
        }
        private void Update()
        {
            out1 = (inputs.Length == 2) ?
                        Logic(inputs[0], inputs[1]) : Logic(inputs[0], inputs[0]);
        }
        public void Input1(bool in1) { Input(0, in1); }
        public void Input2(bool in2) { Input(1, in2); }
        public override string ToString() => $"[{me}]: {out1}";
    }
    class AndGate : LogicElement
    {
        public AndGate(string me) : base(2, me) { }
        public override bool Logic(bool in1, bool in2) => in1 && in2 ? true : false;
    }
    class OrGate : LogicElement
    {
        public OrGate(string me) : base(2, me) { }
        public override bool Logic(bool in1, bool in2) => in1 == false && in2 == false ? false : true;
    }

    class NotGate : LogicElement
    {
        public NotGate(string me) : base(1, me) { }
        public override bool Logic(bool in1, bool in2) => !in1;
    }
    class Port : LogicElement
    {
        public Port(string me) : base(1, me) { }
        public bool Input { set { Input1(value); } }
        public override bool Logic(bool in1, bool in2) => in1;
    }
    class HalfAdder
    {
        public Port portX = new Port("x");
        public Port portY = new Port("y");
        public AndGate carry = new AndGate("cy ");
        public OrGate sum = new OrGate("sum");
        string me;

        NotGate notX = new NotGate("nx");
        NotGate notY = new NotGate("ny");

        AndGate a1 = new AndGate("a1");
        AndGate a2 = new AndGate("a2");
        public HalfAdder(string me)
        {
            this.me = me;
            portX.Output += notX.Input1;
            portX.Output += a2.Input1;
            portX.Output += carry.Input1;

            portY.Output += notY.Input1;
            portY.Output += a1.Input2;
            portY.Output += carry.Input2;

            notX.Output += a1.Input1;
            notY.Output += a2.Input2;

            a1.Output += sum.Input1;
            a2.Output += sum.Input2;
        }
    }
    class FullAdder
    {
        public Port portA = new Port("a");
        public Port portB = new Port("b");
        public Port portC = new Port("cIn");

        private HalfAdder FAsum = new HalfAdder("sum");
        private HalfAdder ha1 = new HalfAdder("HA");
        private OrGate carry = new OrGate("cy ");
        private string me;
        public FullAdder(string me)
        {
            this.me = me;
            portA.Output += ha1.portX.Input1;
            portB.Output += ha1.portY.Input1;
            portC.Output += FAsum.portX.Input1;

            ha1.carry.Output += carry.Input2;
            ha1.sum.Output += FAsum.portY.Input1;
            portC.Output += FAsum.portX.Input1;

            FAsum.carry.Output += carry.Input1;
        }
        class Program
        {

            static void Main(string[] args)
            {
                FullAdder fa = new FullAdder("FA");
                fa.portA.Input = false;
                fa.portB.Input = true;
                fa.portC.Input = false;
                Console.WriteLine($"\n{ fa.FAsum.sum,12}  | {fa.carry}");

                fa.portC.Input = true;
                Console.WriteLine($"\n{ fa.FAsum.sum,12}  | {fa.carry}");
                
                fa.portA.Input = true;
                Console.WriteLine($"\n{ fa.FAsum.sum,12}  | {fa.carry}");


            }
        }
    }
}
