﻿using System;
using System.Collections.Generic;

namespace _14Verein
{
    class Mitglied
    {
        public String Name { get; set; }
        public int Alter { get; set; }
        public int Gewicht { get; set; }
    }
    delegate void NeuesMitglied(List<Mitglied> mListe, Mitglied m);
    class Verein
    {
        List<Mitglied> mitglieder;
        public event NeuesMitglied Neuzugang;

        /* Methode „void Eintreten(Mitglied mitglied)“. 
         * Die Methode soll die Instanz des übergebenen Mitglieds in einer internen 
         * Liste speichern.Nach dem Einfügen in die Liste soll das Event Neuzugang 
         * ausgelöst werden, wenn mindestens eine Methode am Event registriert ist. 
         * Falls es keine Methode gibt, soll nichts geschehen.
        */
        public void Eintreten(Mitglied mitglied)
        {
            mitglieder.Add(mitglied);
            Neuzugang?.Invoke(mitglieder, mitglied);
        }
    }

    class Test
    {
        static void AeltereMitglieder(List<Mitglied> mListe, Mitglied m)
        {
            foreach (var item in mListe)
            {
                if (item.Alter > m.Alter)
                    Console.WriteLine(item.Name);
            }
        }
        public static void Test1000()
        {
            Verein v1 = new Verein();
            v1.Neuzugang += AeltereMitglieder;
            //v1.Neuzugang += (ml, m) =>
            //{
            //    foreach (var item in ml)
            //    {
            //        if (item.Alter > m.Alter)
            //            Console.WriteLine(item.Name);
            //    }
            //};
        }
    }

    // program.cs
    class Program
    {

        static void Main(string[] args)
        {
            //Test.Test1000();
        }
    }
}
